/* 
 * ļʵȱ 1.2.1
 * һļģΪ̣ȻڸôϽļϵͳ
 * ṩļʺ
 * ߣSunner Sun
 * ޸ʱ䣺2005-4-1 11:56
 */

#include <stdio.h>
#include <string.h>

/*************** ʹõĺͺ ********************/

#define SECTOR_SIZE		256		/* ÿĴС */
#define TOTAL_SECTOR	128		/*  */

/* Ѵ̵ĵsectorݶ뵽buf
   sector0ʼ
   ȷط0ֵ󷵻0 */
int read_disk(int sector, void* buf);

/* bufSECTOR_SIZEֽڵд̵ĵsector
   sector0ʼ
   ȷط0ֵ󷵻0 */
int write_disk(int sector, void* buf);

/*************** ʹõĺͺ *****************/

/* ļϵͳйصĳʼڴ
   ɹط0ֵ򷵻0 */
int init_fs(void)
{
	return !0;
}

/* ļfilenameͷʼsizeСݵbuf
   ļʵݲsizeжٶ
   ʵʶֽ0 */
int my_read(const char* filename, void* buf, int size)
{
	return 0;
}

/* bufָsizeСд뵽ļfilename
   ļڣ½ڣ͸
   ɹط0ֵ򷵻0 */
int my_write(const char* filename, void* buf, int size)
{
	return 0;
}



/************************************************
 * ΪmainҪʹõݣҪ޸ģҲ迼 *
 * ר溯Ĺܼ                   *
 * Ȼгв                         *
 ************************************************/
int write_file(void);
int read_file(void);
int get_filename(char* filename);
int get_file_content(char* buf);
int init_disk(void);
void close_disk(void);

#define MAX_FINENAME_LEN	20
#define MAX_BUF_LEN			4*SECTOR_SIZE

int main(void)
{
	int ch = 0;
	int rtn = 1;
	
	if (!init_disk())
	{
		perror("vdisk.dat");
		return -1;
	}

	if (!init_fs())
	{
		printf("init_fs() error!\n");
		return -2;
	}

	do
	{
		switch (ch)
		{
		case 'w':
			getchar();
			rtn = write_file();
			break;
		case 'r':
			getchar();
			rtn = read_file();
			break;
		case '\n':
			continue;
			break;
		}
		if (!rtn)
			printf("\nError!!!!\n");
		printf("Input \'w\' to write, \'r\' to read and \'q\' to quit:");

	} while ((ch=getchar()) != 'q');

	close_disk();
	return 0;
}

int write_file(void)
{
	char filename[MAX_FINENAME_LEN];
	char buf[MAX_BUF_LEN];
	int rtn=0;

	if(get_filename(filename))
	{
		int n = get_file_content(buf);
		rtn = my_write(filename, buf, n);
	}
	else
	{
		rtn = 0;
	}

	return rtn;
}

int read_file(void)
{
	char filename[MAX_FINENAME_LEN];
	char buf[MAX_BUF_LEN];
	int rtn=0;

	if(get_filename(filename))
	{
		int i;

		rtn = my_read(filename, buf, MAX_BUF_LEN);
		for (i=0; i<rtn; i++)
			putchar(buf[i]);
	}
	else
	{
		rtn = 0;
	}

	return rtn;
}

int get_filename(char* filename)
{
    int len;
    
	printf("Enter filename:");
	fgets(filename, MAX_FINENAME_LEN, stdin);
    len = strlen(filename);
    
    if (filename[len-1] == '\n')
    {
        filename[len-1] = '\0';
        len--;
    }
	return len;
}

int get_file_content(char* buf)
{
	int ch, count=0;

	printf("Input file content. Input '~' to end.\n");

	while ((ch = getchar()) != '~')
	{
		buf[count] = ch;
		count++;
	}

	return count;
}

FILE* disk = NULL;

int init_disk(void)
{
	char dump[SECTOR_SIZE] = {0};
	int count=0;

	while (disk == NULL && count < 4)
	{
		disk = fopen("vdisk.dat", "r+b");
		count++;
		if (disk == NULL) /* ļڣ */
		{
			int i;
			disk = fopen("vdisk.dat", "wb");
			if (disk == NULL)
				return 0;
			for (i=0; i<TOTAL_SECTOR; i++)
				fwrite(dump, SECTOR_SIZE, sizeof(char), disk);
			fclose(disk);
			disk = NULL;
		}
	}

	return (int)disk;
}

void close_disk(void)
{
	fclose(disk);
}

int read_disk(int sector, void* buf)
{
	if (!init_disk())
		return 0;

	fseek(disk, sector*SECTOR_SIZE, SEEK_SET);
	return fread(buf, SECTOR_SIZE, 1, disk);
}

int write_disk(int sector, void* buf)
{
	if (!init_disk())
		return 0;

	fseek(disk, sector*SECTOR_SIZE, SEEK_SET);
	return fwrite(buf, SECTOR_SIZE, 1, disk);
}
